type file;
type RData;

# fixme: extend to enable coaster and non-coaster execution
#        needs to select between EvalRPersistent and simple RunR
#        enable persistent for local mode (not sure how)
#        condense stdout/err to 1 file
#        replace ack with ftracef to result pipe
#        condense shellscript and rserverscript to one?

app (external e, RData result, file stout, file sterr) runR (file shellscript, file RServerScript, RData rcall, RData exports[])
{
  bash @shellscript @RServerScript @rcall @result "--imports" @exports 
            stdout=@stout stderr=@sterr;
}

app ack (external e[])
{
#  bash "-c" "echo SIGNAL DONE >/dev/tty; echo done > /tmp/SwiftR/swiftserver/resultpipe";
   bashlocal "-c" @strcat("echo done > ",resultPipeName);
}

app passivate ()
{
  bash "-c" "echo dummy swift job;";
}

(external e[]) apply (string runDir)
{
  RData rcalls[]  <simple_mapper; location=runDir, prefix="cbatch.", suffix=".Rdata", padding=0>;
  RData results[] <simple_mapper; location=runDir, prefix="rbatch.", suffix=".Rdata", padding=0>;
  file  stout[]   <simple_mapper; location=runDir, prefix="stdout.", suffix=".txt", padding=0>;
  file  sterr[]   <simple_mapper; location=runDir, prefix="stderr.", suffix=".txt", padding=0>;

  # Load list of exported files
  string export_list[] = readData(@strcat(runDir, "/exports.txt"));
  RData exports[] <array_mapper; files=export_list>;

  file  runRscript <"EvalRBatchPersistent.sh">;
  file  rsScript   <"SwiftRServer.R">;

  foreach c, i in rcalls {
    (e[i], results[i],stout[i], sterr[i]) = runR(runRscript,rsScript,c, exports);
  }
}

passivate();

string pipedir = @arg("pipedir");
global string requestPipeName = @strcat(pipedir,"/requestpipe");
global string resultPipeName = @strcat(pipedir,"/resultpipe");

iterate serially {
  boolean done;
  string dir;

  # FIXME: read swiftserver dir via @args
  trace("top of loop: rserver waiting for input on", requestPipeName);
  dir = readData(requestPipeName); # Reads direct from this local pipe. Assumes Swift started in right dir.
  trace("rserver: got dir", dir);

  external wait[];
  wait = apply(dir);

  if (dir=="done") { done=true; } else { done=false;}

  #  file f<"/tmp/SwiftR/swiftserver/resultpipe">;
  #  f = writeData("completed\n");  # Doesnt work: runs as soon as the block is entered.
  #  want: tracef("%k completed\n", "my/responsepipe.fifo", wait);
  #  %k waits for wait to be fully closed; then sends formatted string to specified file(doing open, write, close).

  // ack(wait);

  fprintf(resultPipeName, "%kdone\n", wait);

} until (done);
